--Server
local socket = require "socket"
local udp = socket.udp()
udp:settimeout(0)
udp:setsockname("*", 2001)
local world = {nodes = {}; players = {}}
local data, msg_or_ip, port_or_nil
local player, cmd, parms

local worldSizeMinX, worldSizeMaxX, worldSizeMinY, worldSizeMaxY = -1000, 1000, -1000, 1000

local playerColors = {blue = 91, 192, 235; yellow = 253, 231, 76; green = 155, 197, 61; red = 195, 66, 63}

local command = {}

local newVertices
local l
local r

local input = ""
local running = true
while running do
	data, msg_or_ip, port_or_nil = udp:receivefrom()
	--Generate Nodes
	if #world.nodes < 10 then
		for a, b in pairs(world.players) do
			l = math.random(worldSizeMinX, worldSizeMaxX)
			r = math.random(worldSizeMinY, worldSizeMaxY)
			newName = os.time() + #world.nodes * 0.1
			table.insert(world.nodes, {name = newName, health = 100, posX = l, posY = r, rot = 0})
			udp:sendto("createNode "..newName.." "..tonumber(100).." "..l.." "..r, b.ip, b.port)
		end
	end

	--Player Stuff
	if data then
		print(data)
		for i in string.gmatch(data, "%S+") do
			table.insert(command, i)
		end
		if command[1] == "updatePos" then
			--print("Updating Position for "..msg_or_ip..":"..port_or_nil)
			if world.players[command[2]] then
				world.players[command[2]] = {posX = command[3], posY = command[4], ip = msg_or_ip, port = port_or_nil}
			else
				world.players[command[2]] = {posX = command[3], posY = command[4], ip = msg_or_ip, port = port_or_nil}

				for _, node in pairs(world.nodes) do
					udp:sendto("createNode "..node.name.." "..node.health.." "..node.posX.." "..node.posY, msg_or_ip, port_or_nil)
				end
			end
			for a, b in pairs(world.players) do
				if a ~= command[2] then
					--print("Sending to "..c.ip..":"..c.port.." "..b.ip..":"..b.port.." info a:"..a)
					print(command[2])
					udp:sendto("updatePos "..command[2].." "..command[3].." "..command[4], b.ip, b.port)
				end
			end
		elseif command[1] == "nodeMined" then	
			for _, node in pairs(world.nodes) do
				if tonumber(command[2]) == tonumber(node.name) then
					node.health = node.health - command[3]
					for _, player in pairs(world.players) do
						if player.ip ~= msg_or_ip or player.port ~= port_or_nil then --this may be a tad bit risky but idk
							for a, player2 in pairs(world.players) do
								if player2.ip == msg_or_ip and player2.port == port_or_nil then
									udp:sendto("updateNode "..command[2].." "..node.health.." "..a, player.ip, player.port)
								end
							end
						end
					end
				end
			end
		end
		command = {}
	end
	socket.sleep(0.016)
end