local game = {}

local player = require "src.class.player"
local players = require "src.class.players"
local enviroment = require "src.class.enviroment"
local console = require "src.class.console"

local keyWUp = false
local keySUp = false
local keyAUp = false
local keyDUp = false

function game:update(udp)
	
	player:update(udp)
	players:update(udp)
	enviroment:update(udp)

	--Player Movement
	if keyWUp == true then
		player:move("+y")
	end
	if keySUp == true then
		player:move("-y")
	end
	if keyAUp == true then
		player:move("+x")
	end
	if keyDUp == true then
		player:move("-x")
	end
end

function game:draw()
	local screenWidth = love.graphics.getWidth()
	local screenHeight = love.graphics.getHeight()

	console:draw()

	--Move Camera
	love.graphics.translate(player:getPositionX() * -1 + screenWidth/2 - 5, player:getPositionY() * - 1 + screenHeight/2 - 5)

	--Draw Stats
	love.graphics.setColor(255, 255, 255)
	love.graphics.print("FPS: "..love.timer.getFPS()..string.char(10).."Resolution: "..screenWidth.."x"..screenHeight..string.char(10).."Position: X:"..player:getPositionX().." Y: "..player:getPositionY(), 0, 0)

	player:draw()
	players:draw()
	enviroment:draw()
end

function game:keyWUp()
	keyWUp = true
end

function game:keyWDown()
	keyWUp = false
end

function game:keySUp()
	keySUp = true
end

function game:keySDown()
	keySUp = false
end

function game:keyAUp()
	keyAUp = true
end

function game:keyADown()
	keyAUp = false
end

function game:keyDUp()
	keyDUp = true
end

function game:keyDDown()
	keyDUp = false
end

return game